SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 4/22/2013 20:44'!
bla
	"comment stating purpose of message"

	| |
	 ^self! !

!IdiomTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 4/22/2013 20:58'!
assert: aClosure takesNoLongerThan: duration 
	"comment stating purpose of message"
 
	| millisecondsBeforeRunning millisecondsAfterRunning |
	
	millisecondsBeforeRunning := Time millisecondClockValue.
	aClosure value.
	millisecondsAfterRunning := Time millisecondClockValue.
	
	self assert: (millisecondsAfterRunning-millisecondsBeforeRunning) < duration 
	 
	 ! !

!IdiomTest methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 4/22/2013 21:19'!
assertFails: aClosure with: errorType check: aClosure1 and:  aClosure2
	"comment stating purpose of message"
 
 

	[ aClosure value.
	self fail ]
		on: errorType
		do: [ :anError | 
			self assert: (aClosure1 value: anError).
			self assert: (aClosure2 value: anError). ]! !

!IdiomTest methodsFor: 'testing' stamp: 'FacundoPippia 4/22/2013 21:02'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	| customerBook   |
	
	customerBook := CustomerBook  new.
	  
	self assert:  [customerBook addCustomerNamed: 'John Lennon'.] takesNoLongerThan: 50
! !

!IdiomTest methodsFor: 'testing' stamp: 'FacundoPippia 4/22/2013 21:03'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook   johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	
	customerBook addCustomerNamed: johnLennon.
   
	self assert:  [customerBook removeCustomerNamed: johnLennon.]  takesNoLongerThan: 100! !

!IdiomTest methodsFor: 'testing' stamp: 'FacundoPippia 4/22/2013 21:23'!
test03CanNotAddACustomerWithEmptyName 

	| customerBook |
			
	customerBook := CustomerBook new.
 
	
      self assertFails:	[ customerBook addCustomerNamed: ''. ]
	       with: Error
	       check: [ :anError | anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage.]
	       and: [ :anError | customerBook isEmpty]! !

!IdiomTest methodsFor: 'testing' stamp: 'FacundoPippia 4/22/2013 21:24'!
test04CanNotRemoveAndInvalidCustomer
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.
	 

    self assertFails:	[ customerBook removeCustomerNamed: 'Paul McCartney'. ]
	       with: NotFound
	       check: [ :anError | customerBook numberOfCustomers = 1.]
	       and: [ :anError | (customerBook includesCustomerNamed: johnLennon)]! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
